import React, { useEffect, useCallback, useState, useMemo } from "react";
import logo from "./logo.svg";
import "./App.css";
import Converter from "./helper/converter";

const Inputs = { toDecimal: "toDecimal", toRoman: "toRoman" };

function App() {
  // form
  const [toDecimalValue, setToDecimalValue] = useState("");
  const [toRomanValue, setToRomanValue] = useState("");

  const handleChange = useCallback(e => {
    e.preventDefault();
    const value = e.target.value.trim().toUpperCase();
    if (value) {
      if (e.target.name === Inputs.toDecimal) {
        setToDecimalValue(value);
      } else {
        setToRomanValue(value);
      }
    }
  }, []);

  useEffect(() => {
    console.log(toDecimalValue, toRomanValue);
  }, [toDecimalValue, toRomanValue]);

  // convert values
  const convertedDecimal = useMemo(() => {
    const romanToBeConverted = toDecimalValue;
    return Converter.fromRoman(romanToBeConverted);
  }, [toDecimalValue]);

  const convertedRoman = useMemo(() => {
    const decimalToBeConverted = toRomanValue;
    return Converter.toRoman(decimalToBeConverted);
  }, [toRomanValue]);

  return (
    <div className="App">
      <header className="App-header">
        <img src={logo} className="App-logo" alt="logo" />
        <p>{`Available range: from ${Converter.decimalLimit[0]} to ${Converter.decimalLimit[1]}`}</p>
        <h3>Converter: Roman to Decimal</h3>
        <input
          name={Inputs.toDecimal}
          onChange={handleChange}
          placeholder="Enter Roman number here"
        />
        <span>Decimal value is: {convertedDecimal}</span>
        <span>---</span>
        <h3>Converter: Decimal to Roman</h3>
        <input
          name={Inputs.toRoman}
          onChange={handleChange}
          placeholder="Enter Decimal number here"
        />
        <span>Roman value is: {convertedRoman}</span>
      </header>
    </div>
  );
}

export default App;
